#!/usr/bin/perl -I. -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/ftp

use Sauce::Util;
use Sauce::Config;
use Sauce::Service;
use ftp;
use CCE;

my $cce = new CCE;
$cce->connectuds();

my @oids = $cce->find('System');
if (not @oids) {
	$cce->bye('FAIL');
	exit 1;
}

my ($ok, $obj) = $cce->get($oids[0], 'Ftp');
unless ($ok and $obj) {
	$cce->bye('FAIL');
	exit 1;
}

# handle connections
my %settings;
$settings{'MaxClients'} = $obj->{maxConnections};
Sauce::Util::editblock('/etc/proftpd.conf',
		       *Sauce::Util::keyvalue_edit_fcn,
		       '# begin global -- do not delete',
		       '# end global -- do not delete',
		       '#', ' ', undef, %settings);

# handle guest
my $err = Sauce::Util::editblock(ftp::ftp_getconf, *ftp::edit_anon,
				 '# begin anonymous -- do not delete',
				 '# end anonymous -- do not delete',
				 $obj->{guestEnabled}, 
				 $obj->{guestUser}, $obj->{guestGroup},
				 $obj->{guestWorkGroup});

# handle enabled
my $old = Sauce::Service::service_get_inetd('ftp') ? 'on' : 'off';
my $new = $obj->{enabled} ? 'on' : 'off';
if ($new ne $old) {
  Sauce::Service::service_set_inetd('ftp', $new);
  Sauce::Service::service_send_signal('inetd', 'HUP');
}

$cce->bye('SUCCESS');
exit 0;
